<?php

use think\migration\Migrator;
use think\migration\db\Column;

class CreateMetaCampaignsTable extends Migrator
{
    public function change()
    {
        $table = $this->table('ad_meta_campaigns');
        $table->addColumn('campaign_name', 'string', ['limit' => 255])
            ->addColumn('campaign_id', 'string', ['limit' => 255, 'unique' => true])
            ->addColumn('status', 'string', ['limit' => 50])
            ->addColumn('objective', 'string', ['limit' => 100])
            ->addColumn('business_account_id', 'integer')
            ->addForeignKey('business_account_id', 'meta_business_accounts', 'id', ['delete' => 'CASCADE'])
            ->addColumn('created_at', 'timestamp', ['default' => 'CURRENT_TIMESTAMP'])
            ->addColumn('updated_at', 'timestamp', ['default' => 'CURRENT_TIMESTAMP', 'update' => 'CURRENT_TIMESTAMP'])
            ->create();
    }
}
